#!/usr/bin/perl -w

# LSB Test Execution Framework
# Administration Page Module (tests_admin.pl)
#
# Copyright (C) 2007 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Templates;
use Fcntl ':flock';

print "HTTP/1.0 200 OK\n";
print "Content-type: text/html\n\n";

print_header("LSB Application Testkit Administration", "admin");

print "<h1>LSB Application Testkit Administration</h1>\n";

print show_error_dlg("");

`head -n 1 $SERVER_PARAM{APP_DATA}/log/atk-server.log.8889 2>/dev/null` =~ m/PID: (\d+)\.$/i;
my $serv_pid = $1;

my $serv_status;
my $serv_stop_button;
if ($serv_pid) {
	$serv_status = "<font color=\"green\">Running</font> (PID: $serv_pid)";
	$serv_stop_button = " onclick=\"javascript:going_to_kill($serv_pid, 'server');\"";
}
else {
	$serv_status = "<b><font color=\"red\">PID not found!</font></b>";
	$serv_stop_button = " disabled=\"disabled\"";
}

print <<DATA;
<div id="ajax_loading" style="display: none; position: fixed; width: 150px; height: 70px; border: solid 1px #00007f; background-color: #e7f0ff; text-align: center; padding: 6px;">
Please, wait...<br />
<img src="images/environment-spacer.gif" width="1" height="5" alt="" /><br />
<img src="images/ajax_progress.gif" width="16" height="16" alt="" /><br />
<img src="images/environment-spacer.gif" width="1" height="7" alt="" /><br />
<input type="button" name="ajax_abort" id="ajax_abort" value="Abort" style="border: solid 1px #00007f; background: #e0e0ff; color: blue; width: 80px;" onclick="javascript:onAbort();" />
</div>

<div id="disable_layer" style="display: none; position: fixed; width: 100%; height: 100%; top: 0px; left: 0px; background-color: gray; opacity: 0.4; filter: alpha(opacity=40);"></div>

<table cellpadding="0" cellspacing="0" id="server_stopped" style="display: none; position: fixed; width: 350px; height: 70px; border: solid 1px #00007f; background-color: #e7f0ff; text-align: center; vertical-align: middle;padding: 6px;"><tr><td>
<font size="+2" color="red"><b>Server is stopped</b></font>
</td></tr></table>

<table class="main" cellpadding="2" cellspacing="2">
  <tr>
    <td width="100">Server status:</td>
    <td width="150" id="server_status">$serv_status</td>
    <td><input type="button" id="server_stop" style="width: 90px;" value="Stop server"$serv_stop_button /></td>
  </tr>
</table>

<script language="javascript" type="text/javascript">
// <![CDATA[
var err_area = document.getElementById('error_msg_area');
var err_text = document.getElementById('error_msg_text');

// AJAX
var req;
var busy = false;
var ajax_srv_url = document.location.protocol + '//' + document.location.host + '/ajax_srv.pl';
var progressDiv = document.getElementById('ajax_loading');
if (navigator.appName == 'Microsoft Internet Explorer')
	progressDiv.style.height = '90px';
else if (navigator.appName == 'Konqueror')
	progressDiv.style.height = '80px';

function going_to_kill(pid, what) {
	if (!busy) {
		if (confirm("Do you really want to kill the process tree (PID: " + pid + ")?")) {
			setBusyOn();
			loadXMLDoc(ajax_srv_url + '?action=stop_tests&tree=' + what, 'GET', null);
		}
	}
}

function setBusyOn() {
	busy = true;
	var wnd_width = (document.body.clientWidth || window.innerWidth);
	var wnd_height = (document.body.clientHeight || window.innerHeight);
	progressDiv.style.left = Math.ceil((wnd_width - 150) / 2) + 'px';
	progressDiv.style.top = Math.ceil((wnd_height - 70) * 0.4) + 'px';
	setTimeout("showAjaxProgress()", 150);
}

function showAjaxProgress() {
	if (busy)
		progressDiv.style.display = '';
}

function setBusyOff() {
	busy = false;
	progressDiv.style.display = 'none';
}

function onAbort() {
	setBusyOff();
	req.abort();
}

function loadXMLDoc(url, method, post_params) {
	err_area.style.display = 'none';
	if (window.XMLHttpRequest) {        // native XMLHttpRequest object
		req = new XMLHttpRequest();
	}
	else if (window.ActiveXObject) {    // IE/Windows ActiveX version
		try {
			req = new ActiveXObject('Msxml2.XMLHTTP');
		}
		catch (e) {
			try {
				req = new ActiveXObject('Microsoft.XMLHTTP');
			}
			catch (e) {
				alert('Sorry, your browser does not support AJAX');
				return false;
			}
		}
	}
	if (!req) {
		alert('Sorry, your browser does not support AJAX');
		return false;
	}

    req.onreadystatechange = processReqChange;
    req.open(method, url, true);
	req.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
	req.setRequestHeader('If-Modified-Since', 'Tue, 01 Jan 1980 00:00:00 GMT');
	req.setRequestHeader('Content-length', (post_params ? post_params.length : 0));
	req.setRequestHeader('Connection', 'close');
    req.send(post_params);

	function processReqChange() {
		if (req.readyState == 4) {     // Finished
			setBusyOff();
	        if (req.status == 200) {
				if (req.responseXML.getElementsByTagName('error').length > 0) {
		            var error_text = req.responseXML.getElementsByTagName('error')[0].childNodes[0].nodeValue;
	            	err_text.innerHTML = error_text;
	            	err_area.style.display = '';
				}
				else {
	            	err_area.style.display = 'none';
					if (req.responseXML.getElementsByTagName('stopped').length > 0) {
						var stopped = req.responseXML.getElementsByTagName('stopped')[0].childNodes[0].nodeValue;
						var what = req.responseXML.getElementsByTagName('stopped')[0].getAttribute('id');
						var server_status = document.getElementById('server_status');
						var server_stop = document.getElementById('server_stop');
						if (server_status && server_stop) {
							server_status.innerHTML = '<font color="red">Not running</font>';
							server_stop.disabled = true;
							var server_stopped = document.getElementById('server_stopped');
							var wnd_width = (document.body.clientWidth || window.innerWidth);
							var wnd_height = (document.body.clientHeight || window.innerHeight);
							server_stopped.style.left = Math.round((wnd_width - parseInt(server_stopped.style.width)) / 2) + 'px';
							server_stopped.style.top = Math.round((wnd_height - parseInt(server_stopped.style.height)) * 0.4) + 'px';
							server_stopped.style.display = '';
							var show_disable_layer = true;
							if (navigator.appName == 'Konqueror') {
								show_disable_layer = false;
							}
							else if (navigator.appName == 'Microsoft Internet Explorer') {
								var idx = navigator.appVersion.indexOf('MSIE ');
								if (idx == -1) {
									show_disable_layer = false;
								}
								else {
									if (navigator.appVersion.substr(idx + 5, 1) < '7')
										show_disable_layer = false;
								}
							}
							if (show_disable_layer)
								document.getElementById('disable_layer').style.display = '';
						}
					}
				}
	        }
	        else {
	            alert('Error in AJAX call:\\n' + req.statusText);
	        }
	    }
	}
}
// ]]>
</script>
DATA

print_footer();
